/* AKMAP.C
Arabic Transliteration Keyboard Mapping for
Win9x KBDA1.KBD

2 April 2001

ECdS traditional, but with </> and <!> both generating alif.

The output file must be called KBDA1.KBD and placed in
C:\WINDOWS\SYSTEM or whatever corresponds.

*/


#include <jhmdos.h>
/* #include <cp1256.h> -- display constants here and now */

/* Definition of "Windows Arabic" (Codepage 1256)
plus Persian glyphs as found in WinMe system fonts (Times
New Roman, Courier New, Arial and Tahoma).

*/



#define WA_COMMA	0xA1
#define WA_SEMICOLON	0xBA
#define WA_QMARK	0xBF
#define WA_OPENQUOTE	0xBB	/* >> and << glyphs */
#define WA_CLOSEQUOTE	0xAB

#define WA_HAMZA	0xC1
#define WA_ALIFMADDA	0xC2
#define WA_ALIFHAMZA	0xC3
#define WA_WHAMZA	0xC4
#define WA_HAMZABELOW	0xC5
#define WA_EHAMZA	0xC6
#define WA_ALIF		0xC7
#define WA_B		0xC8
#define WA_MARBUTA	0xC9
#define WA_T	0xCA
#define WA_TH	0xCB
#define WA_J	0xCC
#define WA_HX	0xCD
#define WA_KH	0xCE
#define WA_D	0xCF
#define WA_DH	0xD0
#define WA_R	0xD1
#define WA_Z	0xD2
#define WA_S	0xD3
#define WA_SH	0xD4
#define WA_SX	0xD5
#define WA_DX	0xD6

#define WA_TX	0xD8
#define WA_ZX	0xD9
#define WA_AYN	0xDA
#define WA_GH	0xDB
#define WA_TATWIL 	0xDC
#define WA_F	0xDD
#define WA_Q	0xDE
#define WA_K	0xDF

#define WA_L	0xE1

#define WA_M	0xE3
#define WA_N	0xE4
#define WA_H	0xE5
#define WA_W	0xE6

#define WA_E	0xEC
#define WA_Y	0xED

#define WA_AN	0xF0
#define WA_UN	0xF1
#define WA_IN	0xF2
#define WA_A	0xF3

#define WA_U	0xF5
#define WA_I	0xF6

#define WA_SHADDA	0xF8

#define WA_SUKUN	0xFA

#define WA_P	0x81
#define WA_CH	0x8D
#define WA_ZH	0x8E
#define WA_G	0x90
#define WA_K2	0x98

/* CP1256.H ends */


/* errors with "string.h" ?? */

extern char * entry strncpy( UBYTE *gpcTo, UBYTE *gpcFrom, UWORD wCount ) ;

/* Basic ASCII keyboard
char gcLower1[13+1] = "`1234567890-=" ;
char gcLower2[13+1] = "qwertyuiop[]\\" ;
char gcLower3[11+1] = "asdfghjkl;'" ;
char gcLower4[10+1] = "zxcvbnm,./" ;

char gcUpper1[13+1]= "~!@#$%^&*()_+" ;
char gcUpper2[13+1]= "QWERTYUIOP{}|";
char gcUpper3[11+1]= "ASDFGHJKL:\"" ;
char gcUpper4[10+1]= "ZXCVBNM<>?" ;
*/

char gcLower1[13+1] = "`1234567890-=" ;
UBYTE gbLowGlyph1[13] = { "`1234567890-=" } ;

char gcLower2[13+1] = "qwertyuiop[]\\" ;
UBYTE gbLowGlyph2[13] = 
{ WA_Q, WA_W, WA_E, WA_R, WA_T, WA_Y, WA_U, WA_I, WA_AYN, WA_P, WA_ZH, WA_DH, '\\' } ;

char gcLower3[11+1] = "asdfghjkl;'" ;
UBYTE gbLowGlyph3[11] =
{ WA_A, WA_S, WA_D, WA_F, WA_GH, WA_H, WA_J, WA_K, WA_L, WA_SEMICOLON, WA_ALIFHAMZA } ;

char gcLower4[10+1] = "zxcvbnm,./" ;
UBYTE gbLowGlyph4[10] =
{ WA_Z, WA_KH, WA_HAMZA, '?', WA_B, WA_N, WA_M, WA_COMMA, '.', WA_ALIF } ;

/**************/

char gcUpper1[13+1]= "~!@#$%^&*()_+" ;
UBYTE gbUpGlyph1[13] =
{ '?', WA_ALIF, WA_ALIFMADDA, WA_SUKUN, WA_SH, WA_TH, '?', WA_AYN, '*', '(', ')', WA_TATWIL, WA_MARBUTA } ;

char gcUpper2[13+1]= "QWERTYUIOP{}|";
UBYTE gbUpGlyph2[13] =
{ WA_Q, WA_WHAMZA, WA_EHAMZA, WA_ZH, WA_TX, WA_E, WA_U, WA_I, WA_AYN, WA_P, WA_OPENQUOTE, WA_CLOSEQUOTE, ':' } ;

	/* NB. <:> is $ad:a+.  The vertical bar key yields a colon. */ 


char gcUpper3[11+1]= "ASDFGHJKL:\"" ;
UBYTE gbUpGlyph3[11] =
{ WA_AN, WA_SX, WA_DX, WA_F, WA_G, WA_HX, WA_CH, WA_K2, WA_L, WA_SHADDA, WA_HAMZABELOW } ;

char gcUpper4[10+1]= "ZXCVBNM<>?" ;

UBYTE gbUpGlyph4[10] = 
{ WA_ZX, WA_KH, WA_CH, '?', WA_B, WA_N, WA_M, '<', '>', WA_QMARK } ;


UBYTE gbBuffer[ 600 ] ;

UBYTE entry main( void )
{
static UWORD w ;
register UBYTE *p ;

w = ReadSmallFile( "kbda1.000", gbBuffer, sizeof( gbBuffer ) ) ;
if ( w != 556 )
	perish( "Missing or erroneous KBDA1.000" ) ;

p = gbBuffer + 0x132 ;

strncpy( p, gbLowGlyph1, 13 ) ;
p += 13 ;
strncpy( p, gbLowGlyph2, 13 ) ;
p += 13 ;
strncpy( p, gbLowGlyph3, 11 ) ;
p += 11 ;
strncpy( p, gbLowGlyph4, 10 ) ;


p = gbBuffer + 0x162 ;

strncpy( p, gbUpGlyph1, 13 ) ;
p += 13 ;
strncpy( p, gbUpGlyph2, 13 ) ;
p += 13 ;
strncpy( p, gbUpGlyph3, 11 ) ;
p += 11 ;
strncpy( p, gbUpGlyph4, 10 ) ;


w = WriteSmallFile( "KBDA1.KBD", gbBuffer, 556 ) ;
if ( w != 556 )
	perish( "Error saving revised KBDA1.KBD" ) ;

return 0 ;
}

